import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @record
 * @template T
 */

// unsupported: template constraints.
/**
 * @template T
 */
class ResultSet {
    /**
     * @param {?} instantiable
     */
    constructor(instantiable) {
        this.instantiable = instantiable;
        this.records = new Array();
    }
    /**
     * @param {?} obj
     * @return {?}
     */
    assign(obj) {
        this.currentPage = obj.currentPage;
        this.pageSize = obj.pageSize;
        this.hasNextResults = obj.hasNextResults;
        this.hasPreviousResults = obj.hasPreviousResults;
        this.totalRecordsCount = obj.totalRecordsCount;
        this.records = new Array();
        this.numPages = obj.numPages;
        for (var /** @type {?} */ i = 0; i < obj.records.length; i++) {
            var /** @type {?} */ newRecord = new this.instantiable();
            newRecord.assign(obj.records[i]);
            this.records.push(newRecord);
        }
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @template TKey, TValue
 */
class KeyValuePair {
    /**
     * @param {?} key
     * @param {?} value
     */
    constructor(key, value) {
        this.key = undefined;
        this.value = undefined;
        this.key = key;
        this.value = value;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class ArrayTools {
    /**
     * @param {?} array
     * @param {?} criteria
     * @return {?}
     */
    static filter(array, criteria) {
        var /** @type {?} */ filtered = [];
        for (var /** @type {?} */ i = 0; i < array.length; i++) {
            if (criteria(array[i]))
                filtered.push(array[i]);
        }
        return filtered;
    }
    /**
     * @template T
     * @param {?} array
     * @param {?} criteria
     * @return {?}
     */
    static filterGeneric(array, criteria) {
        var /** @type {?} */ filtered = [];
        for (var /** @type {?} */ i = 0; i < array.length; i++) {
            if (criteria(array[i]))
                filtered.push(array[i]);
        }
        return filtered;
    }
    /**
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    static delete(item, array) {
        var /** @type {?} */ index = array.indexOf(item);
        if (index >= 0)
            array.splice(index, 1);
    }
    /**
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    static add(item, array) {
        array.push(item);
    }
    /**
     * @param {?} array
     * @return {?}
     */
    static clear(array) {
        array.splice(0, array.length);
    }
    /**
     * @param {?} index
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    static insertAfter(index, item, array) {
        if ((index >= 0) && (index < array.length)) {
            array.splice(index, 0, item);
        }
    }
    /**
     * @param {?} index
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    static insertBefore(index, item, array) {
        if ((index >= 1) && (index < array.length)) {
            array.splice(index - 1, 0, item);
        }
    }
    /**
     * @param {?} firstArray
     * @param {?} secondArray
     * @return {?}
     */
    static anyOfFirstIsInSecond(firstArray, secondArray) {
        for (var /** @type {?} */ i = 0; i < firstArray.length; i++) {
            if (secondArray.indexOf(firstArray[i]) > -1)
                return true;
        }
        return false;
    }
    /**
     * @param {?} firstArray
     * @param {?} secondArray
     * @return {?}
     */
    static allOfFirstIsInSecond(firstArray, secondArray) {
        for (var /** @type {?} */ i = 0; i < firstArray.length; i++) {
            if (secondArray.indexOf(firstArray[i]) == -1)
                return false;
        }
        return true;
    }
    /**
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    static canMoveUp(item, array) {
        return (array.indexOf(item) > 0);
    }
    /**
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    static canMoveDown(item, array) {
        return (array.indexOf(item) < array.length - 1);
    }
    /**
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    static moveUp(item, array) {
        if (this.canMoveUp(item, array)) {
            var /** @type {?} */ index = array.indexOf(item);
            this.delete(item, array);
            this.insertAfter(index - 1, item, array);
        }
    }
    /**
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    static moveDown(item, array) {
        if (this.canMoveDown(item, array)) {
            var /** @type {?} */ index = array.indexOf(item);
            this.delete(item, array);
            if (index == array.length - 1)
                array.push(item);
            else
                this.insertAfter(index + 1, item, array);
        }
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @template TKey, TValue
 */
class KeyValuePairArray extends Array {
    constructor() {
        super();
    }
    /**
     * @param {?} key
     * @return {?}
     */
    findByKey(key) {
        var /** @type {?} */ matches = ArrayTools.filterGeneric(this, (item) => { return item.key == key; });
        if (matches.length == 0)
            return null;
        return matches[0].value;
    }
    /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    add(key, value) {
        var /** @type {?} */ match = this.findByKey(key);
        if (match == null)
            this.push(new KeyValuePair(key, value));
    }
    /**
     * @param {?} key
     * @return {?}
     */
    remove(key) {
        var /** @type {?} */ match = this.findByKey(key);
        if (match != null)
            ArrayTools.delete(match, this);
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class FoundationsModule {
}
FoundationsModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule
                ],
                declarations: []
            },] },
];
/** @nocollapse */
FoundationsModule.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Generated bundle index. Do not edit.
 */

export { ResultSet, KeyValuePair, KeyValuePairArray, FoundationsModule };
//# sourceMappingURL=ecubed-ng-foundations.js.map
