import { __extends } from 'tslib';
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

var ResultSet = /** @class */ (function () {
    function ResultSet(instantiable) {
        this.instantiable = instantiable;
        this.records = new Array();
    }
    ResultSet.prototype.assign = function (obj) {
        this.currentPage = obj.currentPage;
        this.pageSize = obj.pageSize;
        this.hasNextResults = obj.hasNextResults;
        this.hasPreviousResults = obj.hasPreviousResults;
        this.totalRecordsCount = obj.totalRecordsCount;
        this.records = new Array();
        this.numPages = obj.numPages;
        for (var i = 0; i < obj.records.length; i++) {
            var newRecord = new this.instantiable();
            newRecord.assign(obj.records[i]);
            this.records.push(newRecord);
        }
    };
    return ResultSet;
}());
var KeyValuePair = /** @class */ (function () {
    function KeyValuePair(key, value) {
        this.key = undefined;
        this.value = undefined;
        this.key = key;
        this.value = value;
    }
    return KeyValuePair;
}());
var ArrayTools = /** @class */ (function () {
    function ArrayTools() {
    }
    ArrayTools.filter = function (array, criteria) {
        var filtered = [];
        for (var i = 0; i < array.length; i++) {
            if (criteria(array[i]))
                filtered.push(array[i]);
        }
        return filtered;
    };
    ArrayTools.filterGeneric = function (array, criteria) {
        var filtered = [];
        for (var i = 0; i < array.length; i++) {
            if (criteria(array[i]))
                filtered.push(array[i]);
        }
        return filtered;
    };
    ArrayTools.delete = function (item, array) {
        var index = array.indexOf(item);
        if (index >= 0)
            array.splice(index, 1);
    };
    ArrayTools.add = function (item, array) {
        array.push(item);
    };
    ArrayTools.clear = function (array) {
        array.splice(0, array.length);
    };
    ArrayTools.insertAfter = function (index, item, array) {
        if ((index >= 0) && (index < array.length)) {
            array.splice(index, 0, item);
        }
    };
    ArrayTools.insertBefore = function (index, item, array) {
        if ((index >= 1) && (index < array.length)) {
            array.splice(index - 1, 0, item);
        }
    };
    ArrayTools.anyOfFirstIsInSecond = function (firstArray, secondArray) {
        for (var i = 0; i < firstArray.length; i++) {
            if (secondArray.indexOf(firstArray[i]) > -1)
                return true;
        }
        return false;
    };
    ArrayTools.allOfFirstIsInSecond = function (firstArray, secondArray) {
        for (var i = 0; i < firstArray.length; i++) {
            if (secondArray.indexOf(firstArray[i]) == -1)
                return false;
        }
        return true;
    };
    ArrayTools.canMoveUp = function (item, array) {
        return (array.indexOf(item) > 0);
    };
    ArrayTools.canMoveDown = function (item, array) {
        return (array.indexOf(item) < array.length - 1);
    };
    ArrayTools.moveUp = function (item, array) {
        if (this.canMoveUp(item, array)) {
            var index = array.indexOf(item);
            this.delete(item, array);
            this.insertAfter(index - 1, item, array);
        }
    };
    ArrayTools.moveDown = function (item, array) {
        if (this.canMoveDown(item, array)) {
            var index = array.indexOf(item);
            this.delete(item, array);
            if (index == array.length - 1)
                array.push(item);
            else
                this.insertAfter(index + 1, item, array);
        }
    };
    return ArrayTools;
}());
var KeyValuePairArray = /** @class */ (function (_super) {
    __extends(KeyValuePairArray, _super);
    function KeyValuePairArray() {
        return _super.call(this) || this;
    }
    KeyValuePairArray.prototype.findByKey = function (key) {
        var matches = ArrayTools.filterGeneric(this, function (item) { return item.key == key; });
        if (matches.length == 0)
            return null;
        return matches[0].value;
    };
    KeyValuePairArray.prototype.add = function (key, value) {
        var match = this.findByKey(key);
        if (match == null)
            this.push(new KeyValuePair(key, value));
    };
    KeyValuePairArray.prototype.remove = function (key) {
        var match = this.findByKey(key);
        if (match != null)
            ArrayTools.delete(match, this);
    };
    return KeyValuePairArray;
}(Array));
var FoundationsModule = /** @class */ (function () {
    function FoundationsModule() {
    }
    return FoundationsModule;
}());
FoundationsModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule
                ],
                declarations: []
            },] },
];
FoundationsModule.ctorParameters = function () { return []; };

export { ResultSet, KeyValuePair, KeyValuePairArray, FoundationsModule };
//# sourceMappingURL=ecubed-ng-foundations.js.map
